#!/usr/bin/python3

import sys
from clunet_client import ClunetClient
from clunet_client import ClunetPacket
from time import sleep
import datetime
import traceback

HOST = "localhost"
LOGIN = "time"
PASSWORD = "..."
COMMAND_TIME = 0x12

now = datetime.datetime.now()
packet = ClunetPacket(
    prio=ClunetPacket.PRIO_NOTICE,
    dst=ClunetPacket.ADDR_BROADCAST,
    cmd=COMMAND_TIME,
    data=bytes([now.hour, now.minute, now.second,
        now.year - 1900, now.month, now.day])
    )

try:
    clunet_client = ClunetClient(login=LOGIN, password=PASSWORD)
    clunet_client.connect()
    clunet_client.send(packet)
    clunet_client.close()
except Exception as error:
    print("Error:", error)
    traceback.print_exc()
