from ipaddress import ip_network

ADDR_SELF=0
ADDR_LIGHT=1
ADDR_DOOR_CONTROL=2
ADDR_RC_RECEIVER=3
ADDR_RC_TRANSMITTER=4
ADDR_TEMP_SENSORS=5
ADDR_INTERCOM=7
ADDR_MOTION_SENSOR1=8
ADDR_MOTION_SENSOR2=9
ADDR_DOOR_LOCK=10
ADDR_NUMPAD=11
ADDR_WINDOW=12
ADDR_DOOR_BELL=13
ADDR_ELECTRIC_METER=14
ADDR_BROADCAST=255

CMD_DISCOVERY=0
CMD_DISCOVERY_RESP=1
CMD_BOOT_CONTROL=2
CMD_REBOOT=3
CMD_BOOT_COMPLETED=4
CMD_DOOR_INFO=5
CMD_DEVICE_POWER_INFO_REQ=6
CMD_DEVICE_POWER_INFO=7
CMD_DEVICE_POWER_SET=8
CMD_SET_TIMER=9
CMD_RC_BUTTON_PRESSED=10
CMD_RC_BUTTON_PRESSED_RAW=11
CMD_RC_BUTTON_SEND=12
CMD_RC_BUTTON_SEND_RAW=13
CMD_LIGHT_LEVEL=14
CMD_ONE_WIRE_START_SEARCH=15
CMD_ONE_WIRE_DEVICE_FOUND=16
CMD_TEMPERATURE=17
CMD_TIME=18
CMD_WHEEL_INFO=19
CMD_VOLTAGE=20
CMD_MOTION=21
CMD_INTERCOM_RING=22
CMD_INTERCOM_MESSAGE=23
CMD_INTERCOM_MODE_REQ=24
CMD_INTERCOM_MODE_INFO=25
CMD_INTERCOM_MODE_SET=26
CMD_INTERCOM_RECORD_REQ=27
CMD_INTERCOM_RECORD_DATA=28
CMD_DOOR_LOCK_SET=29
CMD_DOOR_LOCK_INFO=30
CMD_DOOR_LOCK_REQ=31
CMD_BUTTON=32
CMD_WINDOW_SET=33
CMD_WINDOW_INFO=34
CMD_WINDOW_REQ=35
CMD_DOOR_BELL=36
CMD_ALARM=37
CMD_ELECTRO_METER_SET=38
CMD_ELECTRO_METER_STATS=39
CMD_ELECTRO_METER_POWER_REQ=40
CMD_ELECTRO_METER_POWER_INFO=41
CMD_ELECTRO_METER_STATS_REQ=42
CMD_PING=254
CMD_PING_REPLY=255

users = [
    {
        "login": "console",
        "password": "...",
        "network": ip_network("10.13.0.1"),
        "devices_can_read": range(0, 256),
        "devices_can_write": range(0, 256),
        "commands_can_read": range(0, 256),
        "commands_can_write": range(0, 256),
        "allow_sniff": True
    },
    {
        "login": "mobile",
        "password": "...",
        "network": ip_network("0.0.0.0/0"),
        "devices_can_read": range(0, 256),
        "devices_can_write": range(0, 256),
        "commands_can_read": range(0, 256),
        "commands_can_write": range(0, 256),
        "allow_sniff": False
    },
    {
        "login": "smarthome",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_read": [ADDR_LIGHT, ADDR_WINDOW, ADDR_DOOR_LOCK, ADDR_DOOR_BELL, ADDR_DOOR_CONTROL, ADDR_INTERCOM],
        "devices_can_write": [ADDR_LIGHT, ADDR_WINDOW, ADDR_DOOR_LOCK, ADDR_INTERCOM, ADDR_RC_TRANSMITTER],
        "commands_can_read": range(0, 256),
        "commands_can_write": range(0, 256)
    },
    {
        "login": "time",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_write": range(0, 256),
        "commands_can_write": range(0, 256)
    },
    {
        "login": "temperature",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_read": [ADDR_TEMP_SENSORS],
        "commands_can_read": range(0, 256)
    },
    {
        "login": "electro",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_read": [ADDR_ELECTRIC_METER],
        "devices_can_write": [ADDR_ELECTRIC_METER],
        "commands_can_read": range(0, 256),
        "commands_can_write": range(0, 256)
    },
    {
        "login": "intercom",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_read": [ADDR_INTERCOM],
        "devices_can_write": [ADDR_INTERCOM],
        "commands_can_read": range(0, 256),
        "commands_can_write": range(0, 256)
    },
    {
        "login": "pm-sensor",
        "password": "...",
        "network": ip_network("10.13.0.50"),
        "devices_can_write": range(0, 256),
        "commands_can_write": range(0, 256)
    },
    {
        "login": "cameras",
        "password": "...",
        "network": ip_network("127.0.0.1"),
        "devices_can_read": [ADDR_DOOR_CONTROL, ADDR_DOOR_BELL],
        "commands_can_read": [CMD_DOOR_INFO, CMD_DOOR_BELL]
    }
]
